﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Biblioteque_de_Class
{
    public class Theme
    {
        private string Nom { get; set; }
        private List<string> ListCouleur;

        public Theme(string nom, List<string> listCouleur)
        {
            Nom = nom;
            ListCouleur = listCouleur;
        }

        public string GetNom() { return Nom; }
        public void SetNom(string nom) { Nom = nom; }
        public List<string> GetColorList() { return ListCouleur; }
        public string GetColor(int code) { return ListCouleur[code]; }

        public override string ToString() => $"nom : {Nom} color 1: {ListCouleur[0]}\ncolor 2: {ListCouleur[1]}\ncolor 3: {ListCouleur[2]}\n";

        /// <summary>
        /// changer la couleur spécifique d'un theme
        /// </summary>
        public void ChangeColor(string color, string newColor)
        {
            for (int i = 0; i < ListCouleur.Count; i++)
            {
                if (ListCouleur[i] == color)
                {
                    ListCouleur[i] = newColor;
                }
            }
        }
    }
}
