﻿using Biblioteque_de_Class;
using System.ComponentModel.DataAnnotations.Schema;
using System.Diagnostics;

Database db= new Database();
Utilisateur u = new Utilisateur(Upseudo, Umail, Upassword);
Note n = new Note();
Tags t = new Tags();

int boucle = 0;
while (boucle == 0){
    int choix = 0;
    Console.WriteLine("|--------------------------------------|");
    Console.WriteLine("|                                      |");
    Console.WriteLine("| Menu pour lister les fonctionnalités |");
    Console.WriteLine("|                                      |");
    Console.WriteLine("|--------------------------------------|--------|");
    Console.WriteLine("|                                               |");
    Console.WriteLine("|  1/se connecter                               |");
    Console.WriteLine("|  2/se déconnecter                             |");
    Console.WriteLine("|  3/créer un compte                            |");
    Console.WriteLine("|  4/supprimer un compte                        |");
    Console.WriteLine("|  5/créer note                                 |");
    Console.WriteLine("|  6/supprimer note                             |");
    Console.WriteLine("|  7/créer tag                                  |");
    Console.WriteLine("|  8/ajouter tag                                |");
    Console.WriteLine("|  9/supprimer tag                              |");
    Console.WriteLine("|  10/ajouter image                             |");
    Console.WriteLine("|  11/supprimer image                           |");
    Console.WriteLine("|  12/déplacer image                            |");
    Console.WriteLine("|  13/supprimer tag definitif                   |");
    Console.WriteLine("|  14/Ajouter favori                            |");
    Console.WriteLine("|  15/Supprimer favori                          |");
    Console.WriteLine("|  16/créer un thème                            |");
    Console.WriteLine("|  17/supprimer un thème                        |");
    Console.WriteLine("|  18/modifier un thème                         |");
    Console.WriteLine("|  19/rechercher une note                       |");
    Console.WriteLine("|  20/rechercher une note avec tags             |");
    Console.WriteLine("|  21/rechercher une note avec date             |");
    Console.WriteLine("|  22/modifier tags                             |");
    Console.WriteLine("|  23/modifier compte                           |");
    Console.WriteLine("|  24/modifier note                             |");
    Console.WriteLine("|  25/partage note                              |");
    Console.WriteLine("|  26/modifier role (si proprietaire)           |");
    Console.WriteLine("|  27/supprimer cooperateur                     |");
    Console.WriteLine("|                                               |");
    Console.WriteLine("|-----------------------------------------------|");
    switch (Console.ReadLine())
    {
        case "1": ///Connexion
            Utilisateur u = db.GetUtilisateur(Name);
            db.TrouverMail(u.Mail);
            db.CorrespondPassword(u.Password);
            if (db.ListUtilisateur.Contains(u))
            {
                u.Setconnecte(true);
                Console.WriteLine("Connecté");
                return 0;
            }
            else
            {
                Console.WriteLine("Utilisateur non trouvé.");
                return 1;
            }
            break;

        case "2":///Deconnexion
            u.Setconnecte(false);
            Console.WriteLine("Vous vous êtes déconnecté avec succès.");
            break;

        case "3":///Creer un compte
            string Upseudo;
            string Umail;
            string Upasword;
            Console.WriteLine("Choisissez un pseudo");
            Console.ReadLine(Upseudo);
            Console.WriteLine("Entrez votre adresse mail");
            Console.ReadLine(Umail);
            Console.WriteLine("Saisissez un mot de passe");
            Console.ReadLine(Upassword);
            Utilisateur u1 = new Utilisateur(Upseudo, Umail, Upassword);
            db.AjouterUtilisateur(u1);
            break;

        case "4":///Supprimer Compte
            string Name;
            Console.WriteLine("Chercher utilisateur");
            Console.ReadLine(Name);
            Utilisateur u = db.GetUtilisateur(Name);
            db.TrouverMail(u.Mail);
            db.CorrespondPassword(u.Password);
            if (db.ListUtilisateur.Contains(u))
            {
                db.SuppUtilisateur(u);
                Console.WriteLine("Compte supprimé avec succès.");
                return 0;
            }
            else
            {
                Console.WriteLine("Utilisateur non trouvé.");
                return 1;
            }
            break;

        case "5":///Creer une note
            string nom;
            string logoPath;
            Console.WriteLine("Choisissez un nom");
            Console.ReadLine(nom);
            Console.WriteLine("Choisissez un logo");
            Console.ReadLinr(logoPath);
            Note n = new Note(nom,logoPath,u);
            u.AddNote(nom,logoPath);
            break;
            
        case "6":///Supprimer une note
            u.RechercherNote(note);
            u.SuppNote(note);
            break;

        case "7":///Creer un tag
            string choixNom;
            string choixCouleur;
            Console.WriteLine("Choisissez un nom");
            Console.ReadLine(choixNom);
            Console.WriteLine("Choisissez une couleur");
            Console.ReadLine(choixCouleur);
            u.CreateTag(choixNom,choixCouleur);
            break;

        case "8":///Ajouter un tag a une note
            string name;
            string name2;
            Console.WriteLine("Cherchez une note");
            Console.ReadLine(name2);
            Note note = u.RechercherNote(name2);
            Console.WriteLine("Cherchez un tag");
            Console.ReadLine(name);
            Tags tagToAdd = u.RechercherTags(name);
            u.AddOneTagToNoteList(note,tagToAdd);
            break;

        case "9":///Supprimer un tag a une note
            string name;
            string name2;
            Console.WriteLine("Cherchez une note");
            Console.ReadLine(name2);
            Note note = u.RechercherNote(name2);
            Console.WriteLine("Cherchez un tag");
            Console.ReadLine(name);
            Tags tagToSupp = u.RechercherTags(name);
            u.SupOneTagToNoteList(note,tagToSupp);
            break;

        case "10":///Ajouter une image
            n.AjouterImage(image);
            break;

        case "11":///Supprimer une image
            n.SuppImage(image);
            break;

        case "12":///Deplacer une image
            n.DeplacerImage(image);
            break;

        case "13":///Supprimer un tag definitivement
            Tags t= u.RechercherTags(name);
            n.SuppTag(t);
            db.SupTagBaseData(t);
            break;

        case "14":///AJouter une note en favori
            u.RechercherNote(note);
            u.AddFav(note);
            break;

        case "15":///Supprimer une note des favoris
            u.RechercherNote(note);
            u.SupFav(note);
            break;

        case "16":///Creer un theme
            Theme th = new Theme(nom,listCouleurs);
            db.AjouterTheme(th);
            break;

        case "17":///Supprimer un theme
            th = db.GetTheme(name);
            db.SupTheme(th);
            break;

        case "18":///Modifier un theme
            string Name2;
            Console.WriteLine("Cherchez un theme a modifier");
            Console.ReadLine(Name2);
            th = db.GetTheme(Name2);
            th.ChangeColor(color,newColor);
            db.ModifierNomTheme(th,NewName);
            db.ModifierColorListTheme(th,NewColorList);
            break;

        case "19":///REchercher une note
            Console.WriteLine("Cherchez une note");
            Console.ReadLine(nom);
            u.RechercherNote(u.NoteList, nom);
            break;

        case "20":///Recherche note par tag
            ///u.;
            break;

        case "21":///Recherche note par dateCreation
            ///u.;
            break;

        case "22":///Modifier un tag
            Console.WriteLine("Cherchez un tag");
            Console.ReadLine(t);
            t.SetNom();
            t.SetCouleur();
            break;

        case "23":///Modifier le compte
            int choixModif;
            Console.WriteLine("Modifier pseudo ? Mot de passe ? Mail ? (0/1/2)");
            Console.ReadLine(choixModif);
            if (choixModif == 0)
            {
                u.SetPsd();
            }
            if (choixModif == 1)
            {
                u.setMdp();
            }
            if (choixModif == 2)
            {
                u.setMail();
            }
            break;

        case "24":///Modifier le texte de la note mais jsp c'est quoi qu'il faut set
            n.VerifPriviledge(u);
            if (true)
            {
                n.SetText();
            }
            else
            {
                Console.WriteLine("Vous ne possedez pas les droits pour effectuer cette action.");
            }
            break;

        case "25":///Partager la note
            n.VerifPriviledge(u);
            if (true)
            {
                n.AjouterCoop(u, user);
            }
            break;

        case "26":///Modifier les editeurs
            int choix2 = 0;
            Console.WriteLine("Ajouter editeur ou supprimer editeur ? (0/1)");
            Console.ReadLine(choix2);
            n.VerifPriviledge(user);
            if (true && choix2 == 0)
            {
                n.AjouterEdit(u, user);
            }
            if (true && choix2 == 1)
            {
                n.SupEdit(u, user);
            }
            break;

        case "27":///Supprimer un cooperateur
            n.VerifPriviledge(u);
            if (true)
            {
                n.SupCoop(u, user);
            }
            break;
        default:
            Console.WriteLine("< Veuillez rentrer une des options proposées à l'ecran ! >");
            break;
    }


}